// WordRect: a class that functions like a Fisica FBox,
// but that draws a word instead of a rectangle.  You
// shouldn't need to change anything in this tab.

class WordRect
  extends FBox
{
  String txt;
  float sc;

  // Construct a new WordRect from the actual text of
  // the word and a global scaling factor.
  WordRect( String s, float sc )
  {
    super( 1, 1 );
    this.txt = s;
    setWidth( sc * textWidth( txt ) );
    setHeight( sc * (textAscent() + textDescent()) );
    setPosition( width/2, height/2 );
    setVelocity( random( -5, 5 ), random( -5, 5 ) );
    this.sc = sc;
  }
  
  void draw( PGraphics g )
  {
    // Uncomment the next line if you want to be able to
    // see the rectangles that surround the words.
    // super.draw( g );
    g.fill( 0 );
    g.pushMatrix();
    g.translate( getX(), getY() );
    g.rotate( getRotation() );
    g.scale( sc );
    g.text( txt, -0.5*textWidth( txt ), textDescent() );
    g.popMatrix();
  }
}